<?php
namespace Teknisa\CTB\Controllers;

use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request\Row;
use Zeedhi\Framework\DTO\Response\Error;
use Teknisa\CTB\Services\Ctb32700DREAnualService;

class Ctb32700DREAnualController {

    protected $ctb32700DREAnualService;
    
    public function __construct(Ctb32700DREAnualService $ctb32700DREAnualService) {
        $this->ctb32700DREAnualService = $ctb32700DREAnualService;
    }
    
    /**
     * Gera DRE Gerencial - Anual 
     */
    public function geraDREAnual(Row $request, Response $response) {
        try {
            $row = $request->getRow();

            $cdempresa    = $row['CDEMPRESA'];
            $dtctbinicial = $row['DTCTBINICIAL'];
            $cdtipodemo   = $row['CDTIPODEMO'];
            $cdfilial     = $row['CDFILIAL'];
            
            $nrcontabger = $this->ctb32700DREAnualService->geraDREAnual(
                $cdempresa, $dtctbinicial, $cdtipodemo, $cdfilial
            );

            $relatorios[] = ['NRCONTABGER' => $nrcontabger];
            $response->addDataSet(new DataSet('geraDREAnual', ['relatorios' => $relatorios]));
        } catch(\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }

}
