<?php

namespace Teknisa\CTB\Services;

use Zeedhi\Framework\DTO\Response;
use Teknisa\CTB\Factories\Ger09400ParametroContabilFactory;
use Teknisa\Libs\Util\DateUtil;
use Zeedhi\Framework\DataSource\DataSet;

class Ger09400ParametroContabilService{

    protected $ger09400ParametroContabilFactory;
    protected $environment;
    protected $nrorg;
    
    const EMPRESA_DESTINO_CADASTRADA = "EMPRESA_DESTINO_CADASTRADA";
    const EMPRESA_ORIGEM_NAO_CADASTRADA = "EMPRESA_ORIGEM_NAO_CADASTRADA";

    public function __construct(Ger09400ParametroContabilFactory $ger09400ParametroContabilFactory, $environment) {
        $this->ger09400ParametroContabilFactory = $ger09400ParametroContabilFactory;
        $this->environment = $environment;
        $this->nrorg = $environment->getNrOrg();
    }
    
    public function cadastramentoAutomatico($row, $cdempresa){
        $params = [];
        if ($row['IDALTERAPERIODO'] === 'S'){
            $params['DTINILANC'] = $row['DTINICLANC'];
            $params['DTFINLANC'] = $row['DTFINALANC'];
            $params['DTINIRELA'] = $row['DTINICCONT'];
            $params['DTFINRELA'] = $row['DTFINACONT'];
            $params['DTINIPER'] = $row['DTINICCONT'];
            $params['DTFINPER'] = $row['DTFINACONT'];
            $params['DTINIFIN'] = $row['DTINICCTBL'];
            $params['DTFINFIN'] = $row['DTFINACCTBL'];
            $params['DTINIDFE'] = $row['DTINIINTCONTDFE'];
            $params['DTFINDFE'] = $row['DTFININTCONTDFE'];
            $params['DTINIDFS'] = $row['DTINIINTCONTDFS'];
            $params['DTFINDFS'] = $row['DTFININTCONTDFS'];
            $params['DTINIGPA'] = $row['DTINIINTCONTGPA'];
            $params['DTFINGPA'] = $row['DTFININTCONTGPA'];
            $params['CDEMPRESA'] = $cdempresa;
            $this->ger09400ParametroContabilFactory->cadastramentoAutomaticoEmpresaAlteracaoPeriodos($params);
        }
        if ($row['IDALTERALANCAMENTO'] === 'S'){
            $params['CONTGERE'] = $row['IDCONTGERE'];
            $params['CONTCOME'] = $row['IDCONTCOME'];
            $params['IDUTCUSTEST'] = $row['IDUTCUSTESTCONT'];
            $params['IDSUGRAT'] = $row['IDSUGRAT'];
            $params['IDUTSALDOSOC'] = $row['IDUTSALDOSOC'];
            $params['IDMSMCONTA'] = $row['IDMSMCONTADBCR'];
            $params['IDRETESTSETOR'] = $row['IDRETESTSETOR'];
            $params['IDCONSVNDDFS'] = $row['IDMSMCONTADBCR'];
            $params['IDDESPTRIBDIFAL'] = $row['IDDESPTRIBDIFAL'];
            $params['IDCONSDTMOVIRETEST'] = $row['IDCONSDTMOVIRETEST'];
            $params['CDEMPRESA'] = $cdempresa;
            $this->ger09400ParametroContabilFactory->cadastramentoAutomaticoEmpresaAlteracaoControles($params);
        }
    }
    
    public function validateSaldoPositivo($cdempresa, $dtinicial){
        $params = [];
        $params['CDEMPRESA'] = $cdempresa;
        $params['DTINICIAL'] = $dtinicial;
        return $this->ger09400ParametroContabilFactory->validateSaldoPositivo($params);
    }
    
    public function validateLacnamentoPendenteRecalculo($cdempresa){
        $params = [];
        $params['CDEMPRESA'] = $cdempresa;
        return $this->ger09400ParametroContabilFactory->validateLacnamentoPendenteRecalculo($params);
    }

}